

package bigdata.stream


import org.eclipse.paho.client.mqttv3._
import org.eclipse.paho.client.mqttv3.persist.MemoryPersistence


import org.apache.spark.SparkContext
import org.apache.spark.SparkContext._
import org.apache.spark.SparkConf
import org.apache.spark.streaming.mqtt._
import org.apache.spark.streaming._
import org.apache.spark.streaming.StreamingContext._
import org.apache.spark.storage.StorageLevel

object SparkMQTTTest {
 def main(args: Array[String]) {
    if (args.length < 2) {
        System.err.println("       Usage: SparkMQTTTest <MqttbrokerUrl> <topic>")
        System.err.println(args.length)
        System.exit(1)
    }   
    val Seq(brokerUrl, topic) = args.toSeq

    val sparkConf = new SparkConf().setAppName("MQTTTest")

    val ssc = new StreamingContext(sparkConf, Seconds(2))

    val messages = MQTTUtils.createStream(ssc, brokerUrl, topic, StorageLevel.MEMORY_ONLY_SER_2)

    val count = messages.countByWindow(Seconds(10), Seconds(2))

    count.print()

    ssc.checkpoint("hdfs://quickstart.cloudera:8020/user/cloudera/cp")

    ssc.start()

    ssc.awaitTermination()
 }
}
