

package bigdata.stock


import org.apache.spark.SparkContext
import org.apache.spark.SparkContext._
import org.apache.spark.SparkConf



object SparkStockCount {
  def main(args: Array[String]) {

    val sc = new SparkContext(new SparkConf().setAppName("Spark Stock Count"))
        
    //dataset format: exchange, stock_symbol, date, stock_price_open,stock_price_high,stock_price_low, stock_price_close, stock_volume,stock_price_adj_close.
    val stocks = sc.textFile("hdfs://quickstart.cloudera:8020/user/cloudera/stock")

    //We print the total amount of records in the dataset for reference
    System.out.println("Number of records: " + stocks.count)

    //PROBLEM: count number of unique companies in the dataset (stock symbols)

    //selecting second element from the array with (1) in Scala
    val symbols = stocks.map(x => x.split(",")(1))
    val result = symbols.distinct()

    System.out.println("Unique companies: " + result.count)


  }
}
